<template>
  <div class="container h-100 d-flex justify-content-center align-items-center">
    <div class="col-lg-6">
      <h1 class="text-center mb-4">Register</h1>
      <div class="card">
        <div class="card-body">
          <p v-if="successMessage" class="success-message">
              {{ successMessage }}
            </p>
            <p v-if="errorMessage" class="error-message">
            {{ errorMessage }}
          </p>
          <form :model="registerRequest">
            <div class="form-group mb-3">
              <label for="name">Name</label>
              <input v-model="registerRequest.username" type="text" class="form-control" id="name" placeholder="Enter name">
            </div>
            <div class="form-group mb-3">
              <label for="email">Email address</label>
              <input v-model="registerRequest.email" type="email" class="form-control" id="email" aria-describedby="emailHelp" placeholder="Enter email">
            </div>
            <div class="form-group mb-3">
              <label for="password">Password</label>
              <input v-model="registerRequest.password" @input="validatePassword" type="password" class="form-control" id="password" placeholder="Password">
            </div>
            <p v-if="passwordError" class="error-message">
                      {{ passwordError }}
                    </p>
            <button type="submit" @click.prevent="registerSubmit" class="btn btn-primary btn-block">Submit</button> &nbsp;&nbsp;&nbsp;
            <router-link class="btn btn-success btn-block" to="/login">Login</router-link>
          </form>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { POST_UTILISATEUR } from "../api/api.js";
import JSEncrypt from 'jsencrypt';
import CryptoJS from 'crypto-js';
export default {
  name: 'RegisterView',
  data() {
    return {
      registerRequest: {
        username: "",
        email: "",
        password: "",
        publicKey: "",
        privateKey: "" // Add this line
        // roles: ["member"],
      },
      passwordError: "",
      successMessage: "",
      errorMessage: "",
    };
  },
  methods: {
    registerSubmit() {
       // Sanitize inputs
    const sanitizedUsername = this.sanitizeInput(this.registerRequest.username);
    const sanitizedEmail = this.sanitizeInput(this.registerRequest.email);
      // Generate a key pair
      const crypt = new JSEncrypt({default_key_size: 1024});
      const privateKey = crypt.getPrivateKey();
      const publicKey = crypt.getPublicKey();

      // Add the public key to the register request
      this.registerRequest.publicKey = publicKey;

      // Derive a key from the username and password
      const key = CryptoJS.PBKDF2(this.registerRequest.password, this.registerRequest.username, { keySize: 128/32 }).toString();

      // Encrypt the private key
      const encryptedPrivateKey = CryptoJS.AES.encrypt(privateKey, key).toString();

      // // Store the private key in local storage
      // localStorage.setItem('privateKey', privateKey);
      this.registerRequest.privateKey = encryptedPrivateKey;

      POST_UTILISATEUR(JSON.parse(JSON.stringify(this.registerRequest)))
        .then((res) => {
          console.log("data: " + res);
          this.successMessage = "User registered successfully"; // Set the success message
          setTimeout(() => this.$router.push({ path: "/login" }), 3000); // Redirect after 3 seconds
          // this.$router.push({ path: "/login" });
        })
        .catch((e) => {
          this.errorMessage = "Error: ", e;
          console.log(e);
        });
    },

    validatePassword() {
      // Reset error message
      this.passwordError = "";

      // Validate password length and mixture of characters
      if (this.registerRequest.password.length < 8) {
        this.passwordError = "Password must be at least 8 characters long.";
      } else if (
        !/[a-zA-Z]/.test(this.registerRequest.password) ||
        !/\d/.test(this.registerRequest.password)
      ) {
        this.passwordError =
          "Password must contain a mixture of letters and numbers.";
      }
    },
    sanitizeInput(input) {
    // Remove script tags, encode special characters, or use a library like DOMPurify
    return input.replace(/<script.*?>.*?<\/script>/gi, '').trim();
  },
  }
}
</script>

<style scoped>
.container {
  height: 100vh; /* Full height of the viewport */
}
.success-message {
  color: green; /* Style as needed */
}
.error-message {
  color: red; /* Style as needed */
}
</style>